;*******************************************************************************
;
;     C Compiler for M16C/80
;     Copyright 1999 MITSUBISHI ELECTRIC CORPORATION
;     AND MITSUBISHI ELECTRIC SEMICONDUCTOR APPLICATION ENGINEERING CORPORATION
;     All Rights Reserved.
;
;     Written by T.Aoyama
;
;     sect30.inc     : section definition
;     This program is applicable when using the basic I/O library
;
;     $Id: sect308.inc,v 1.6.2.3 2001/07/30 11:27:35 muramatu Exp $
;
;******************************************************************************
;---------------------------------------------------------------
;
; 	Arrangement of section
;
;---------------------------------------------------------------
; Near RAM data area
;---------------------------------------------------------------
; SBDATA area
	.section	data_SE,DATA
	.org	400H
data_SE_top:

	.section	bss_SE,DATA,ALIGN
bss_SE_top:

	.section	data_SO,DATA
data_SO_top:

	.section	bss_SO,DATA
bss_SO_top:

; near RAM area
	.section	data_NE,DATA,ALIGN
data_NE_top:

	.section	bss_NE,DATA,ALIGN
bss_NE_top:

	.section	data_NO,DATA
data_NO_top:

	.section	bss_NO,DATA
bss_NO_top:

;---------------------------------------------------------------
; Stack area
;---------------------------------------------------------------
	.section	stack,DATA,ALIGN
	.blkb	STACKSIZE
	.align
stack_top:

	.blkb	ISTACKSIZE
	.align
istack_top:


;---------------------------------------------------------------
;	heap section
;---------------------------------------------------------------
	.section	heap,DATA
heap_top:
	.blkb	HEAPSIZE

;---------------------------------------------------------------
; Near ROM data area
;---------------------------------------------------------------
	.section	rom_NE,ROMDATA,ALIGN
rom_NE_top:

	.section	rom_NO,ROMDATA
rom_NO_top:

;---------------------------------------------------------------
; Far RAM data area
;---------------------------------------------------------------
	.section	data_FE,DATA
	.org		10000H
data_FE_top:

	.section	bss_FE,DATA,ALIGN
bss_FE_top:
 
	.section	data_FO,DATA
data_FO_top:
 
	.section	bss_FO,DATA
bss_FO_top:


;---------------------------------------------------------------
; Far ROM data area
;---------------------------------------------------------------
	.section	rom_FE,ROMDATA
	.org		0FF0000H
rom_FE_top:

	.section	rom_FO,ROMDATA
rom_FO_top:

;---------------------------------------------------------------
; Initial data of 'data' section
;---------------------------------------------------------------
	.section	data_SEI,ROMDATA
data_SEI_top:

	.section	data_SOI,ROMDATA
data_SOI_top:

	.section	data_NEI,ROMDATA
data_NEI_top:
 
	.section	data_NOI,ROMDATA
data_NOI_top:
 
	.section	data_FEI,ROMDATA
data_FEI_top:
 
	.section	data_FOI,ROMDATA
data_FOI_top:

;---------------------------------------------------------------
; code area
;---------------------------------------------------------------
	.section	interrupt,ALIGN

	.section	program,ALIGN

	.section	program_S
	.org		0FE0000H

;---------------------------------------------------------------
; variable vector section
;---------------------------------------------------------------
    .section    vvector_FE,ROMDATA          ; variable vector table
;;  .section    vector                      ; Variable Interrupt Vector Table
    .org        VECTOR_ADR

	.lword	dummy_int		; BRK (software int 0)
	.lword	dummy_int		; 
	.lword	dummy_int		; 
	.lword	dummy_int		; 
	.lword	dummy_int		; 
	.lword	dummy_int		; 
	.lword	dummy_int		; 
	.lword	dummy_int		; 
	.lword	dummy_int		; DMA0 (software int 8)
	.lword	dummy_int 		; DMA1 (software int 9)
	.lword	dummy_int 		; DMA2 (software int 10)
	.lword	dummy_int 		; DMA3 (software int 11)
	.glb    _LS_DetectTimeOut
	.lword	_LS_DetectTimeOut		; TIMER A0 (software int 12)
;	.lword	dummy_int		; TIMER A0 (software int 12)
	.lword	dummy_int		; TIMER A1 (software int 13)
	.lword	dummy_int		; TIMER A2 (software int 14)
	.lword	dummy_int		; TIMER A3 (software int 15)
	.lword	dummy_int		; TIMER A4 (software int 16)
	.glb    _LS_LinSndInt
	.lword	_LS_LinSndInt		; uart0 trance (software int 17)
;	.lword	dummy_int		; uart0 trance (software int 17)
	.glb    _LS_LinRcvInt
	.lword	_LS_LinRcvInt		; uart0 receive (software int 18)
;	.lword	dummy_int		; uart0 receive (software int 18)
	.lword	dummy_int		; uart1 trance (software int 19)
	.lword	dummy_int		; uart1 receive (software int 20)
	.lword	dummy_int		; TIMER B0 (software int 21)
	.lword	dummy_int		; TIMER B1 (software int 22)
	.lword	dummy_int		; TIMER B2 (software int 23)
	.lword	dummy_int		; TIMER B3 (software int 24)
	.lword	dummy_int		; TIMER B4 (software int 25)
	.lword	dummy_int		; INT5 (software int 26)
	.lword	dummy_int		; INT4 (software int 27)
	.lword	dummy_int		; INT3 (software int 28)
	.lword	dummy_int		; INT2 (software int 29)
	.lword	dummy_int		; INT1 (software int 30)
	.lword	dummy_int		; INT0 (software int 31)
	.lword	dummy_int		; TIMER B5 (software int 32)
	.lword	dummy_int		; uart2 trance/NACK (software int 33)
	.lword	dummy_int		; uart2 receive/ACK (software int 34)
	.lword	dummy_int		; uart3 trance/NACK (software int 35)
	.lword	dummy_int		; uart3 receive/ACK (software int 36)
	.lword	dummy_int		; uart4 trance/NACK (software int 37)
	.lword	dummy_int		; uart4 receive/ACK (software int 38)
	.lword	dummy_int		; uart2 bus collision (software int 39)
	.lword	dummy_int		; uart3 bus collision (software int 40)
	.lword	dummy_int		; uart4 bus collision (software int 41)
	.lword	dummy_int		; A-D Convert (software int 42)
	.lword	dummy_int		; input key (software int 43)
	.lword	dummy_int		; software int 44
	.lword	dummy_int		; software int 45
	.lword	dummy_int		; software int 46
	.lword	dummy_int		; software int 47
	.lword	dummy_int		; software int 48
	.lword	dummy_int		; software int 49
	.lword	dummy_int		; software int 50
	.lword	dummy_int		; software int 51
	.lword	dummy_int		; software int 52
	.lword	dummy_int		; software int 53
	.lword	dummy_int		; software int 54
	.lword	dummy_int		; software int 55
	.lword	dummy_int		; software int 56
	.lword	dummy_int		; software int 57
	.lword	dummy_int		; software int 58
	.lword	dummy_int		; software int 59
	.lword	dummy_int		; software int 60
	.lword	dummy_int		; software int 61
	.lword	dummy_int		; software int 62
	.lword	dummy_int		; software int 63

;===============================================================
; fixed vector section
;---------------------------------------------------------------
	.section	fvector			; fixed vector table
;===============================================================
; special page defination
;---------------------------------------------------------------
;	macro is defined in ncrt0.a30
;	Format: SPECIAL number
;
;---------------------------------------------------------------
;	SPECIAL 255
;	SPECIAL 254
;	SPECIAL 253
;	SPECIAL 252
;	SPECIAL 251
;	SPECIAL 250
;	SPECIAL 249
;	SPECIAL 248
;	SPECIAL 247
;	SPECIAL 246
;	SPECIAL 245
;	SPECIAL 244
;	SPECIAL 243
;	SPECIAL 242
;	SPECIAL 241
;	SPECIAL 240
;	SPECIAL 239
;	SPECIAL 238
;	SPECIAL 237
;	SPECIAL 236
;	SPECIAL 235
;	SPECIAL 234
;	SPECIAL 233
;	SPECIAL 232
;	SPECIAL 231
;	SPECIAL 230
;	SPECIAL 229
;	SPECIAL 228
;	SPECIAL 227
;	SPECIAL 226
;	SPECIAL 225
;	SPECIAL 224
;	SPECIAL 223
;	SPECIAL 222
;	SPECIAL 221
;	SPECIAL 220
;	SPECIAL 219
;	SPECIAL 218
;	SPECIAL 217
;	SPECIAL 216
;	SPECIAL 215
;	SPECIAL 214
;	SPECIAL 213
;	SPECIAL 212
;	SPECIAL 211
;	SPECIAL 210
;	SPECIAL 209
;	SPECIAL 208
;	SPECIAL 207
;	SPECIAL 206
;	SPECIAL 205
;	SPECIAL 204
;	SPECIAL 203
;	SPECIAL 202
;	SPECIAL 201
;	SPECIAL 200
;	SPECIAL 199
;	SPECIAL 198
;	SPECIAL 197
;	SPECIAL 196
;	SPECIAL 195
;	SPECIAL 194
;	SPECIAL 193
;	SPECIAL 192
;	SPECIAL 191
;	SPECIAL 190
;	SPECIAL 189
;	SPECIAL 188
;	SPECIAL 187
;	SPECIAL 186
;	SPECIAL 185
;	SPECIAL 184
;	SPECIAL 183
;	SPECIAL 182
;	SPECIAL 181
;	SPECIAL 180
;	SPECIAL 179
;	SPECIAL 178
;	SPECIAL 177
;	SPECIAL 176
;	SPECIAL 175
;	SPECIAL 174
;	SPECIAL 173
;	SPECIAL 172
;	SPECIAL 171
;	SPECIAL 170
;	SPECIAL 169
;	SPECIAL 168
;	SPECIAL 167
;	SPECIAL 166
;	SPECIAL 165
;	SPECIAL 164
;	SPECIAL 163
;	SPECIAL 162
;	SPECIAL 161
;	SPECIAL 160
;	SPECIAL 159
;	SPECIAL 158
;	SPECIAL 157
;	SPECIAL 156
;	SPECIAL 155
;	SPECIAL 154
;	SPECIAL 153
;	SPECIAL 152
;	SPECIAL 151
;	SPECIAL 150
;	SPECIAL 149
;	SPECIAL 148
;	SPECIAL 147
;	SPECIAL 146
;	SPECIAL 145
;	SPECIAL 144
;	SPECIAL 143
;	SPECIAL 142
;	SPECIAL 141
;	SPECIAL 140
;	SPECIAL 139
;	SPECIAL 138
;	SPECIAL 137
;	SPECIAL 136
;	SPECIAL 135
;	SPECIAL 134
;	SPECIAL 133
;	SPECIAL 132
;	SPECIAL 131
;	SPECIAL 130
;	SPECIAL 129
;	SPECIAL 128
;	SPECIAL 127
;	SPECIAL 126
;	SPECIAL 125
;	SPECIAL 124
;	SPECIAL 123
;	SPECIAL 122
;	SPECIAL 121
;	SPECIAL 120
;	SPECIAL 119
;	SPECIAL 118
;	SPECIAL 117
;	SPECIAL 116
;	SPECIAL 115
;	SPECIAL 114
;	SPECIAL 113
;	SPECIAL 112
;	SPECIAL 111
;	SPECIAL 110
;	SPECIAL 109
;	SPECIAL 108
;	SPECIAL 107
;	SPECIAL 106
;	SPECIAL 105
;	SPECIAL 104
;	SPECIAL 103
;	SPECIAL 102
;	SPECIAL 101
;	SPECIAL 100
;	SPECIAL 99
;	SPECIAL 98
;	SPECIAL 97
;	SPECIAL 96
;	SPECIAL 95
;	SPECIAL 94
;	SPECIAL 93
;	SPECIAL 92
;	SPECIAL 91
;	SPECIAL 90
;	SPECIAL 89
;	SPECIAL 88
;	SPECIAL 87
;	SPECIAL 86
;	SPECIAL 85
;	SPECIAL 84
;	SPECIAL 83
;	SPECIAL 82
;	SPECIAL 81
;	SPECIAL 80
;	SPECIAL 79
;	SPECIAL 78
;	SPECIAL 77
;	SPECIAL 76
;	SPECIAL 75
;	SPECIAL 74
;	SPECIAL 73
;	SPECIAL 72
;	SPECIAL 71
;	SPECIAL 70
;	SPECIAL 69
;	SPECIAL 68
;	SPECIAL 67
;	SPECIAL 66
;	SPECIAL 65
;	SPECIAL 64
;	SPECIAL 63
;	SPECIAL 62
;	SPECIAL 61
;	SPECIAL 60
;	SPECIAL 59
;	SPECIAL 58
;	SPECIAL 57
;	SPECIAL 56
;	SPECIAL 55
;	SPECIAL 54
;	SPECIAL 53
;	SPECIAL 52
;	SPECIAL 51
;	SPECIAL 50
;	SPECIAL 49
;	SPECIAL 48
;	SPECIAL 47
;	SPECIAL 46
;	SPECIAL 45
;	SPECIAL 44
;	SPECIAL 43
;	SPECIAL 42
;	SPECIAL 41
;	SPECIAL 40
;	SPECIAL 39
;	SPECIAL 38
;	SPECIAL 37
;	SPECIAL 36
;	SPECIAL 35
;	SPECIAL 34
;	SPECIAL 33
;	SPECIAL 32
;	SPECIAL 31
;	SPECIAL 30
;	SPECIAL 29
;	SPECIAL 28
;	SPECIAL 27
;	SPECIAL 26
;	SPECIAL 25
;	SPECIAL 24
;	SPECIAL 23
;	SPECIAL 22
;	SPECIAL 21
;	SPECIAL 20
;	SPECIAL 19
;	SPECIAL 18
;
;===============================================================
; fixed vector section
;---------------------------------------------------------------
	.org	0FFFFDCh
UDI:
	.lword	dummy_int
OVER_FLOW:
	.lword	dummy_int
BRKI:
	.lword	dummy_int
ADDRESS_MATCH:
	.lword	dummy_int
SINGLE_STEP:
	.lword	dummy_int
WDT:
	.lword	dummy_int
DBC:
	.lword	dummy_int
NMI:
	.lword	dummy_int
RESET:
	.lword	start
;
;*******************************************************************************
;
;     C Compiler for M16C/80
;     Copyright 1999 MITSUBISHI ELECTRIC CORPORATION
;     AND MITSUBISHI ELECTRIC SEMICONDUCTOR APPLICATION ENGINEERING CORPORATION
;     All Rights Reserved.
;
;*******************************************************************************

