/*
 *	TOPPERS/NonOSΉLINʐM~hEFA
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		NonOSΉLINʐM~hEFASlavepbP[W
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *	Version 1.00  2007.10.29
 */

#include "slin.h"
#include "slin_sfr.h"

/*** FUNCTION prototype ***/
/* API */
l_bool l_sys_init(void);
void l_ifc_init(void);
l_bool l_ifc_connect(void);
l_bool l_ifc_disconnect(void);
l_bool l_wakeup(void);
l_bool l_sleep(void);
l_bool l_run(void);

#if LIN_SND_NUM
l_bool l_set_sndreq(slib_slot_def *lin_frame);
l_bool l_stop_sndreq(slib_slot_def *lin_frame);
l_u8 l_read_sndsts(slib_slot_def *lin_frame);
l_bool l_clr_sndsts(slib_slot_def *lin_frame);
void l_set_snddata(slib_slot_def *lin_fram, l_u8 *lin_buffer);
#endif

#if LIN_RCV_NUM
l_bool l_set_rcvreq(slib_slot_def *lin_frame);
l_bool l_stop_rcvreq(slib_slot_def *lin_frame);
l_u8 l_read_rcvsts(slib_slot_def *lin_frame);
l_bool l_clr_rcvsts(slib_slot_def *lin_frame);
l_bool l_get_rcvdata(slib_slot_def *lin_fram, l_u8 *lin_buffer);
#endif

void LS_InitBuffer(void);

void LS_StopTimer(void);
void LS_StartNoBusActivityTimer(void);
void LS_StartHeaderTimeoutTimer(void);
void LS_StartFrameTimeoutTimer(void);
void LS_StartWakeUpTimer(void);

void LS_EnableReceiveHeader(void);
void LS_EnableTransmitResponse(void);
void LS_EnableReceiveWakeUp(void);
void LS_EnableReceiveSynchBreak(void);

void LS_TransmitError(void);
void LS_TransmitSuccess(void);
void LS_ReceiveError(void);
void LS_ReceiveSuccess(void);

/*** VARIABLE prototype ***/
far const char LS_ID_TBL[] = {
     0x80, 0xC1, 0x42, 0x03, 0xC4, 0x85, 0x06, 0x47 // 0x00 - 0x07
    ,0x08, 0x49, 0xCA, 0x8B, 0x4C, 0x0D, 0x8E, 0xCF // 0x08 - 0x0F
    ,0x50, 0x11, 0x92, 0xD3, 0x14, 0x55, 0xD6, 0x97 // 0x10 - 0x17
    ,0xD8, 0x99, 0x1A, 0x5B, 0x9C, 0xDD, 0x5E, 0x1F // 0x18 - 0x1F
    ,0x20, 0x61, 0xE2, 0xA3, 0x64, 0x25, 0xA6, 0xE7 // 0x20 - 0x27
    ,0xA8, 0xE9, 0x6A, 0x2B, 0xEC, 0xAD, 0x2E, 0x6F // 0x28 - 0x2F
    ,0xF0, 0xB1, 0x32, 0x73, 0xB4, 0xF5, 0x76, 0x37 // 0x30 - 0x37
    ,0x78, 0x39, 0xBA, 0xFB, 0x3C, 0x7D, 0xFE, 0xBF // 0x38 - 0x3F
};
far const char LS_COMP_MASK[] = {~0x01, ~0x02, ~0x04, ~0x08, ~0x10, ~0x20, ~0x40, ~0x80};
/* (10bit*nbyte+10bit)*1.4*16/8 */
far const char LS_FRAME_TIMEOUT[] = {28,56,84,112,140,168,196,224,252};

/* LIN BUFFER */
slib_buffer_def lin_buffer;

/* LIN STATE */
static int lin_state;
#define LIN_IS_RESET        (0)
#define LIN_IS_SLEEP        (1)
#define LIN_IS_WAKEUP       (2)
#define LIN_IS_IDLE         (3)
#define LIN_IS_SB           (4)
#define LIN_IS_SF           (5)
#define LIN_IS_ID           (6)
#define LIN_IS_SD           (7)
#define LIN_IS_SCS          (8)
#define LIN_IS_RD           (9)
#define LIN_IS_RCS          (10)

/* LIN checksum of transmitted data */
static short int lin_checksum;

/* LIN the last transmitted data */
static char lin_tdata;
/* UART baudrate generator */
static char lin_brg;
/* LIN bit time counter */
static short int lin_bit_time;
/* LIN header time out couter */
static unsigned short int lin_header_timeout;

/* LIN temporary buffer which is stored transmitting/receiving message */
typedef struct{
    char slot;
    char byte;
    char byte_max;
    char identifier;
    char data[8];
    char checksum;
}lin_frame_def;
static lin_frame_def lin_tmp;

/* Overflow counter for No-Bus-Activity (100 * 250 = 25,000) */
static unsigned int lin_idle_cnt;
/* WakeUp resend counter */
static char lin_wakeup_cnt;

/*** LIN SPECIFICATION ***/
#define LIN_ID_COMMAND      (0x3C)
#define LIN_DATA_SLEEP      (0x00)
#define LIN_ID_RESPONSE     (0x3D)
#define LIN_ID_EXTENDED     (0x3E)
#define LIN_ID_EXTENSION    (0x3F)


/*>>*+*********************************************************************/
#define LS_SET_LIN_STATE(state)                                            \
/*------------------------------------------------------------------------ \
 Description:                                                              \
   change lin_state\                                                       \
-------------------------------------------------------------------------- \
 Input:     lin_state                                                      \
 Output:    no                                                             \
 After:     no                                                             \
 Note:      no                                                             \
***********************************************************************<<*/\
    (lin_state = state)                                                    \


/*>>*+*********************************************************************/
l_bool l_sys_init(void)
/*------------------------------------------------------------------------
 Description:
   l_sys_init performs the initialization of the LIN SW.
--------------------------------------------------------------------------
 Input:     no
 Output:    [E_OK]: succedded, [E_NG]: failed
 After:     lin_state = LIN_IS_RESET
 Note:      The call to the l_sys_init is the first call a user must use
            in the LIN SW before using any other API functions.
***********************************************************************<<*/
{
    l_bool result;

    result = E_OK;

    /* 2nd, initialize LIN buffer */
    LS_InitBuffer();

    /* 3rd, initialize LIN state */
    LS_SET_LIN_STATE(LIN_IS_RESET);

    return result;
}


/*>>*+*********************************************************************/
void LS_InitBuffer(void)
/*------------------------------------------------------------------------
 Description:
   initialize LIN buffer.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    char cnt;
    char lp_slot;
    char *buf;

    /* lin_buffer */
    buf = (char *)&lin_buffer;
    for(cnt=0; cnt<sizeof(lin_buffer); cnt++) {
        *buf++ = 0;
    }

    /* state */
    lb_state = LIN_ST_RESET;

    /* comp_flag */
    lb_snd_comp = 0;
    lb_rcv_comp = 0;
    
    /* err_flag */
    lb_err_flg = LIN_NO_ERR;

    /* transmit slot */
#if LIN_SND_NUM
    for(lp_slot=0; lp_slot<LIN_SND_NUM; lp_slot++){
        lb_sndslot(lp_slot) = lp_slot;
        lb_sndid(lp_slot) = LIN_SNDFRMID_TBL[lp_slot];
        lb_sndreg(lp_slot) = LIN_DEFAULT_SNDREG;
    }
#endif
    /* receive slot */
#if LIN_RCV_NUM
    for(lp_slot=0; lp_slot<LIN_RCV_NUM; lp_slot++){
        lb_rcvslot(lp_slot) = lp_slot;
        lb_rcvid(lp_slot) = LIN_RCVFRMID_TBL[lp_slot];
        lb_rcvreg(lp_slot) = LIN_DEFAULT_RCVREG;
    }
    
#endif
}


/*>>*+*********************************************************************/
void LS_ResetBuffer(void)
/*------------------------------------------------------------------------
 Description:
   Reset LIN buffer when LIN start running.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    /* comp_flag */
    lb_snd_comp = 0;
    lb_rcv_comp = 0;
    
    /* err_flag */
    lb_err_flg = LIN_NO_ERR;
}


/*>>*+*********************************************************************/
void l_ifc_init(void)
/*------------------------------------------------------------------------
 Description:
   l_ifc_init initialize the controller.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      The interfaces are all listed by their names in the local
            description file.  The call to the l_ifc_init() function is
            the first call a user must perform, before using any other
            interface-related LIN API functions.
***********************************************************************<<*/
{
    /*** initialize UART ***/
    lin_brg = LIN_BRG;
    lin_bit_time = ((short int)LIN_BRG + 1) * LIN_BRGSRC;
    
    LIN_PD6_2 = 0;
    LIN_PS0_2 = 0;
    LIN_PS0_3 = 1;

    /* set UART register */
    LIN_U_TIC = 0;
    LIN_U_RIC = 0;
    LIN_U_MR = 0x05;
    LIN_U_BRG = lin_brg;
    LIN_U_C0 = 0x10;
    LIN_U_C1 = 0x00;
    LIN_U_IRS = 1;

    /*** initialize Timer ***/
    LIN_TIMER_IC = 0;
    LIN_TIMER_START = 0;
    LIN_TIMER_MR = 0x40;
    LIN_TIMER_TIMER = lin_bit_time * ((long int)16*100/(long int)8);

}


/*>>*+*********************************************************************/
l_bool l_ifc_connect(void)
/*------------------------------------------------------------------------
 Description:
   The call to the l_ifc_connect will connect the interface to the LIN 
   network and enable the transmission of data to the bus.
--------------------------------------------------------------------------
 Input:     no
 Output:    [E_OK] succeeded, [E_NG] failed
 After:     no
 Note:      lin_state must be LIN_IS_RESET
***********************************************************************<<*/
{
    l_bool result;

    /* if LIN_IS_RESET, OK. */
    if(lin_state == LIN_IS_RESET){
        LS_EnableReceiveWakeUp();
        lb_state = LIN_ST_SLEEP;
        LS_SET_LIN_STATE(LIN_IS_SLEEP);
        result = E_OK;
    }
    /* if not, NG. */
    else{
        result = E_NG;
    }
    
    return result;
}


/*>>*+*********************************************************************/
l_bool l_ifc_disconnect(void)
/*------------------------------------------------------------------------
 Description:
   The call to the l_ifc_disconnect will disconnect the interface to the 
   LIN network and thus disable the transmission of headers and data to the bus.
--------------------------------------------------------------------------
 Input:     no
 Output:    [E_OK] succeeded, [E_NG] failed
 After:     no
 Note:      lin_state must be LIN_IS_SLEEP
***********************************************************************<<*/
{
    l_bool result;

    /* if LIN_IS_SLEEP, OK. */
    if(lin_state == LIN_IS_SLEEP){
        /* stop UART */
        asm("pushc flg");
        asm("fclr i");
        LIN_U_C1 &= 0xF0;
        LIN_U_TIC = 0;
        LIN_U_RIC = 0;

        /* stop Timer */
        LIN_TIMER_START = 0;
        LIN_TIMER_IC = 0;
        asm("nop");
        asm("nop");
        asm("popc flg");


        lb_state = LIN_ST_RESET;
        LS_SET_LIN_STATE(LIN_IS_RESET);
        result = E_OK;
    }
    /* if not, NG. */
    else{
        result = E_NG;
    }
    
    return result;
}


#if LIN_SND_NUM
/*>>*+*********************************************************************/
l_bool l_set_sndreq(slib_slot_def *lin_frame)
/*------------------------------------------------------------------------
 Description:
   Transmitting permission.
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [E_OK] succeeded, [E_NG] failed
***********************************************************************<<*/
{
    l_bool result;
    l_u8 slot_num;
    
    slot_num = lin_frame->slot;
    if(lb_sndreq(slot_num) == LIN_REQ_SND){
        result = E_NG;
    }
    else{
        lb_sndreq(slot_num) = LIN_REQ_SND;
        result = E_OK;
    }
    
    return result;
}


/*>>*+*********************************************************************/
l_bool l_stop_sndreq(slib_slot_def *lin_frame)
/*------------------------------------------------------------------------
 Description:
   Transmitting stop
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [E_OK] succeeded, [E_NG] failed
***********************************************************************<<*/
{
    l_bool result;
    l_u8 slot_num;
    
    slot_num = lin_frame->slot;
    if(lb_sndreq(slot_num) == LIN_REQ_IDLE){
        result = E_NG;
    }
    else{
        lb_sndreq(slot_num) = LIN_REQ_IDLE;
        result = E_OK;
    }
    
    return result;
}


/*>>*+*********************************************************************/
l_u8 l_read_sndsts(slib_slot_def *lin_frame)
/*------------------------------------------------------------------------
 Description:
   Read send state.
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [LIN_STS_IDEL] idle, [LIN_STS_RUN] run, [LIN_STS_END] end
***********************************************************************<<*/
{
    l_u8 result;
    l_u8 slot_num;
    
    slot_num = lin_frame->slot;
    result = lb_sndsts(slot_num);
    
    return result;
}


/*>>*+*********************************************************************/
l_bool l_clr_sndsts(slib_slot_def *lin_frame)
/*------------------------------------------------------------------------
 Description:
   Clear send state.
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [E_OK] succeeded, [E_NG] failed
***********************************************************************<<*/
{
    l_bool result;
    l_u8 slot_num;
    
    slot_num = lin_frame->slot;
    if(lb_sndsts(slot_num) == LIN_STS_RUN){
        result = E_NG;
    }
    else{
        lb_sndsts(slot_num) = LIN_STS_IDLE;
        lb_snd_comp &= LS_COMP_MASK[slot_num];
        lb_snderr(slot_num) = LIN_NO_ERR;
        result = E_OK;
    }
    
    return result;
}


/*>>*+*********************************************************************/
void l_set_snddata(slib_slot_def *lin_frame, l_u8 *data_buffer)
/*------------------------------------------------------------------------
 Description:
   Set send data.
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    l_u8 snd_req;
    l_u8 slot_num;
    l_u8 cnt;
    
    slot_num = lin_frame->slot;
    snd_req = lb_sndreq(slot_num);
    if(snd_req==LIN_REQ_SND){
        asm("pushc flg");
        asm("fclr i");
        for(cnt=0;cnt<lin_dlc_buffer[lin_frame->id];cnt++){
            lb_snddata(slot_num, cnt) = data_buffer[cnt];
        }
        asm("popc flg");
    }
    else {
        for(cnt=0;cnt<lin_dlc_buffer[lin_frame->id];cnt++){
            lb_snddata(slot_num, cnt) = data_buffer[cnt];
        }
    }
    return;
}
#endif


#if LIN_RCV_NUM
/*>>*+*********************************************************************/
l_bool l_set_rcvreq(slib_slot_def *lin_frame)
/*------------------------------------------------------------------------
 Description:
   Receiving permission.
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [E_OK] succeeded, [E_NG] failed
***********************************************************************<<*/
{
    l_bool result;
    l_u8 slot_num;
    
    slot_num = lin_frame->slot;
    if(lb_rcvreq(slot_num) == LIN_REQ_RCV){
        result = E_NG;
    }
    else{
        lb_rcvreq(slot_num) = LIN_REQ_RCV;
        result = E_OK;
    }
    
    return result;
}


/*>>*+*********************************************************************/
l_bool l_stop_rcvreq(slib_slot_def *lin_frame)
/*------------------------------------------------------------------------
 Description:
   Receiving stop
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [E_OK] succeeded, [E_NG] failed
***********************************************************************<<*/
{
    l_bool result;
    l_u8 slot_num;
    
    slot_num = lin_frame->slot;
    if(lb_rcvreq(slot_num) == LIN_REQ_IDLE){
        result = E_NG;
    }
    else{
        lb_rcvreq(slot_num) = LIN_REQ_IDLE;
        result = E_OK;
    }
    
    return result;
}


/*>>*+*********************************************************************/
l_u8 l_read_rcvsts(slib_slot_def *lin_frame)
/*------------------------------------------------------------------------
 Description:
   Read receive state.
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [LIN_STS_IDLE] idle, [LIN_STS_RUN] run, [LIN_STS_END] end
***********************************************************************<<*/
{
    l_u8 result;
    l_u8 slot_num;
    
    slot_num = lin_frame->slot;
    result = lb_rcvsts(slot_num);
    
    return result;
}


/*>>*+*********************************************************************/
l_bool l_clr_rcvsts(slib_slot_def *lin_frame)
/*------------------------------------------------------------------------
 Description:
   Clear receive state.
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [E_OK] succeeded, [E_NG] failed
***********************************************************************<<*/
{
    l_bool result;
    l_u8 slot_num;
    
    slot_num = lin_frame->slot;
    if(lb_rcvsts(slot_num) == LIN_STS_END){
        lb_rcvsts(slot_num) = LIN_STS_IDLE;
        lb_rcv_comp &= LS_COMP_MASK[slot_num];
        lb_rcverr(slot_num) = LIN_NO_ERR;
        lb_rcvover(slot_num) = LIN_NO_ERR;
        result = E_OK;
    }
    else{
        result = E_NG;
    }
    
    return result;
}


/*>>*+*********************************************************************/
l_bool l_get_rcvdata(slib_slot_def *lin_frame, l_u8 *data_buffer)
/*------------------------------------------------------------------------
 Description:
   Get receive data.
--------------------------------------------------------------------------
 Input:     *lin_frame      frame address
 Output:    no
 After:     no
 Note:      [E_OK] succeeded, [E_NG] failed
***********************************************************************<<*/
{
    l_bool result;
    l_u8 slot_num;
    l_u8 cnt;
    
    slot_num = lin_frame->slot;
    if(lb_rcverr(slot_num) == LIN_NO_ERR){
        for(cnt=0;cnt<lin_dlc_buffer[lin_frame->id];cnt++){
            data_buffer[cnt] = lb_rcvdata(slot_num, cnt);
        }
        result = E_OK;
    }
    else{
        result = E_NG;
    }
    
    return result;
}
#endif


/*>>*+*********************************************************************/
void LS_EnableReceiveSynchBreak(void)
/*------------------------------------------------------------------------
 Description:
   enable receiving SynchBreak by using UART 9bit mode.
   if receive 9bit all "0" and framing error occur, OK.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    /* initialize UART */
    asm("pushc flg");
    asm("fclr i");
    LIN_U_C1 &= 0xF0;      
    LIN_U_MR = 0x06;
    LIN_U_C1 |= 0x04;
    LIN_U_TIC = 0;
    LIN_U_RIC = LIN_UR_INTLEVEL;
    asm("nop");
    asm("nop");
    asm("popc flg");

}


/*>>*+*********************************************************************/
void LS_EnableReceiveHeader(void)
/*------------------------------------------------------------------------
 Description:
   enable LIN reception and receive interrupt by using UART 8bit mode.
   disable transmission interrupt.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    /*** initialize UART ***/
    asm("pushc flg");
    asm("fclr i");
    LIN_U_C1 &= 0xF0;
    LIN_U_MR = 0x05;
    LIN_U_C1 |= 0x04;
    LIN_U_TIC = 0;
    LIN_U_RIC = LIN_UR_INTLEVEL;
    asm("nop");
    asm("nop");
    asm("popc flg");
}


/*>>*+*********************************************************************/
void LS_EnableTransmitResponse(void)
/*------------------------------------------------------------------------
 Description:
   enable LIN transmission of RESPONSE.
   In order to detect bit-error, enable reception too.
   Enable transmission interrupt, but not receive interrupt.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    asm("pushc flg");
    asm("fclr i");
    LIN_U_C1 = 0x00;
    LIN_U_MR = 0x00;
    LIN_U_MR = 0x05;
    LIN_U_C1 = 0x05;
    LIN_U_IRS = 1;
    LIN_U_TIC = LIN_UT_INTLEVEL;
    LIN_U_RIC = 0;
    asm("nop");
    asm("nop");
    asm("popc flg");
}


/*>>*+*********************************************************************/
void LS_EnableReceiveWakeUp(void)
/*------------------------------------------------------------------------
 Description:
   enable receiving wake-up frame by using UART 8bit mode.
   if receive data == 00h/80h/C0h, OK.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    asm("pushc flg");
    asm("fclr i");
    LIN_U_C1 &= 0xF0;
    LIN_U_MR = 0x05;
    LIN_U_C1 |= 0x04;
    LIN_U_TIC = 0;
    LIN_U_RIC = LIN_UR_INTLEVEL;
    asm("nop");
    asm("nop");
    asm("popc flg");
}


/*>>*+*********************************************************************/
l_bool l_wakeup(void)
/*------------------------------------------------------------------------
 Description:
   Send WakeUp frame.
   In UART transmit interrupt, enable detection of SynchBreak.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    l_bool result;
    
    if(lb_state == LIN_ST_SLEEP){
        asm("pushc flg");
        asm("fclr i");
        LIN_U_C1 &= 0xF0;
        LIN_U_MR = 0x05;
        LIN_U_C1 |= 0x05;
        LIN_U_RIC = 0;
        LIN_U_TIC = LIN_UT_INTLEVEL;
        asm("nop");
        asm("nop");
        asm("popc flg");
        lb_state = LIN_ST_WAKEUP;
        LS_SET_LIN_STATE(LIN_IS_WAKEUP);
        LS_StartWakeUpTimer();
        LIN_U_TB = 0x80;

        result = E_OK;
    }
    /* No sleep */
    else{
        result = E_NG;
    }
    
    return result;
}


/*>>*+*********************************************************************/
l_bool l_sleep(void)
/*------------------------------------------------------------------------
 Description:
   Sleep LIN.
--------------------------------------------------------------------------
 Input:     no
 Output:    [E_OK] succeeded, [E_NG] failed
 After:     no
 Note:      no
***********************************************************************<<*/
{
    l_bool result;
    
    if(lb_state == LIN_ST_RUN){
        LS_StopTimer();
        LS_EnableReceiveWakeUp();

        lb_state = LIN_ST_SLEEP;
        LS_SET_LIN_STATE(LIN_IS_SLEEP);
        result = E_OK;
    }
    else{
        result = E_NG;
    }

    return result;
}


/*>>*+*********************************************************************/
l_bool l_run(void)
/*------------------------------------------------------------------------
 Description:
   RUN LIN.
--------------------------------------------------------------------------
 Input:     no
 Output:    [E_OK] succeeded, [E_NG] failed
 After:     no
 Note:      no
***********************************************************************<<*/
{
    l_bool result;
    
    if((lb_state == LIN_ST_SLEEP) || (lb_state == LIN_ST_WAKEUP)){
        LS_EnableReceiveSynchBreak();
        LS_StartNoBusActivityTimer();
        LS_ResetBuffer();
        lb_state = LIN_ST_RUN;
        LS_SET_LIN_STATE(LIN_IS_IDLE);

        result = E_OK;
    }
    else{
        result = E_NG;
    }

    return result;
}


/*>>*+*********************************************************************/
void LS_StopTimer(void)
/*------------------------------------------------------------------------
 Description:
   stop timer for measurment frame-timeout and No-Bus-Activity
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    asm("pushc flg");
    asm("fclr i");
    LIN_TIMER_START = 0;
    LIN_TIMER_IC = 0;
    asm("nop");
    asm("nop");
    asm("popc flg");
}


/*>>*+*********************************************************************/
void LS_StartNoBusActivityTimer(void)
/*------------------------------------------------------------------------
 Description:
   start timer for measurment No-Bus-Activity
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      TIMER count source is set as same as UART BRG source
            TIME-OUT is 1,000bit(if 25times, detect error). 
***********************************************************************<<*/
{
    asm("pushc flg");
    asm("fclr i");
    LIN_TIMER_START = 0;
    LIN_TIMER_MR = 0x40;
    LIN_TIMER_TIMER = lin_bit_time * ((short int)16*100/(short int)8);
    LIN_TIMER_IC = LIN_TIMER_INTLEVEL;
    asm("nop");
    asm("nop");
    asm("popc flg");
    lin_idle_cnt = 0;
    LIN_TIMER_START = 1;
}


/*>>*+*********************************************************************/
void LS_StartHeaderTimeoutTimer(void)
/*------------------------------------------------------------------------
 Description:
   start timer for measurment header timeout
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      TIMER count source is set f8
            TIME-OUT is (34bit+1bit) * 1.4 - 11bit = 38bit
***********************************************************************<<*/
{
    lin_header_timeout = lin_bit_time * (16 * 38 / 8) ;

    asm("pushc flg");
    asm("fclr i");
    LIN_TIMER_START = 0;
    LIN_TIMER_MR = 0x40;
    LIN_TIMER_TIMER = lin_header_timeout;
    LIN_TIMER_IC = LIN_TIMER_INTLEVEL;
    asm("nop");
    asm("nop");
    asm("popc flg");

    LIN_TIMER_START = 1;
}


/*>>*+*********************************************************************/
void LS_StartFrameTimeoutTimer(void)
/*------------------------------------------------------------------------
 Description:
   start timer for measurment frame timeout
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      TIMER count source is set f8
            TIME-OUT is (10bit*nbyte + 10bit) * 1.4 + reat_time
***********************************************************************<<*/
{
    unsigned int rest_time;

    rest_time = LIN_TIMER_TIMER;
    if(rest_time>lin_header_timeout){
        rest_time = 0;
    }

    asm("pushc flg");
    asm("fclr i");
    LIN_TIMER_START = 0;
    LIN_TIMER_MR = 0x40;
    LIN_TIMER_TIMER = lin_bit_time * LS_FRAME_TIMEOUT[lin_tmp.byte_max] + rest_time;
    LIN_TIMER_IC = LIN_TIMER_INTLEVEL;
    asm("nop");
    asm("nop");
    asm("popc flg");


    LIN_TIMER_START = 1;
}


/*>>*+*********************************************************************/
void LS_StartWakeUpTimer(void)
/*------------------------------------------------------------------------
 Description:
   start timer for measurment WakeUpTimer
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      TIMER count source is set as same as UART BRG source
            TIME-OUT is 100bit 
***********************************************************************<<*/
{
    asm("pushc flg");
    asm("fclr i");
    LIN_TIMER_START = 0;
    LIN_TIMER_MR = 0x40;
    LIN_TIMER_TIMER = lin_bit_time * ((short int)16*100/(short int)8);
    LIN_TIMER_IC = LIN_TIMER_INTLEVEL;
    asm("nop");
    asm("nop");
    asm("popc flg");

    lin_wakeup_cnt = 0;
    LIN_TIMER_START = 1;
}


/*>>*+*********************************************************************/
void LS_ReceiveError(void)
/*------------------------------------------------------------------------
 Description:
    Detect receive error during LIN communication.
    Increment receive error counter.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
#if LIN_RCV_NUM
    if(lin_tmp.slot<LIN_RCV_NUM) {
        lb_rcverr(lin_tmp.slot)=LIN_ERR;
        lb_rcvsts(lin_tmp.slot)=LIN_STS_END;
        lb_rcv_comp |= ~LS_COMP_MASK[lin_tmp.slot];
        lb_response_error = LIN_ERR;
    }
#endif
}


/*>>*+*********************************************************************/
void LS_ReceiveSuccess(void)
/*------------------------------------------------------------------------
 Description:
    Receive LIN message successfully.
    Decrement receive error counter.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    /* clear error flag */
    lb_err_flg = LIN_NO_ERR;
}


/*>>*+*********************************************************************/
void LS_TransmitError(void)
/*------------------------------------------------------------------------
 Description:
    Detect transmit error during LIN communication.
    Increment transmit error counter by 8.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
#if LIN_SND_NUM
    lb_snderr(lin_tmp.slot)=LIN_ERR;
    lb_sndsts(lin_tmp.slot)=LIN_STS_END;
    lb_snd_comp |= ~LS_COMP_MASK[lin_tmp.slot];
#endif
}


/*>>*+*********************************************************************/
void LS_TransmitSuccess(void)
/*------------------------------------------------------------------------
 Description:
    Transmit LIN message successfully.
    Decrement receive error counter.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    /* clear error flag */
    lb_err_flg = LIN_NO_ERR;
}


#pragma INTERRUPT LS_DetectTimeOut
/*>>*+*********************************************************************/
void LS_DetectTimeOut(void);
void LS_DetectTimeOut(void)
/*------------------------------------------------------------------------
 Description:
   interrupt when measurement Frame timeout or No-Bus-Activity error.
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    char m_process;
    char m_state;

    switch(lin_state){
    case LIN_IS_IDLE:
        lin_idle_cnt++;
        if(lb_state == LIN_ST_WAKEUP){
            if(lin_idle_cnt >= 150){
                lb_wakeup_error = LIN_ERR;
                lb_no_bus_activity = LIN_ERR;
                lin_idle_cnt = 150;
            }
        }
        else {
            if(lin_idle_cnt >= 250){
                lb_no_bus_activity = LIN_ERR;
                lin_idle_cnt = 250;
            }
        }
        break;
    case LIN_IS_WAKEUP:
        lin_wakeup_cnt++;
        if(lin_wakeup_cnt < 3){
            asm("pushc flg");
            asm("fclr i");
            LIN_U_C1 &= 0xF0;
            LIN_U_MR = 0x05;
            LIN_U_C1 |= 0x05;
            LIN_U_RIC = 0;
            LIN_U_TIC = LIN_UT_INTLEVEL;
            asm("nop");
            asm("nop");
            asm("popc flg");
            lb_state = LIN_ST_WAKEUP;
            LS_SET_LIN_STATE(LIN_IS_WAKEUP);
            LIN_U_TB = 0x80;
        }
        else {
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        break;
    default:
        LS_EnableReceiveSynchBreak();
        LS_StartNoBusActivityTimer();
        if((lin_state == LIN_IS_SD) || (lin_state == LIN_IS_SCS)){
            LS_TransmitError();
        }
        else{
            LS_ReceiveError();
        }
        LS_SET_LIN_STATE(LIN_IS_IDLE);
    }
}


#pragma INTERRUPT LS_LinRcvInt
/*>>*+*********************************************************************/
void LS_LinRcvInt(void);
void LS_LinRcvInt(void)
/*------------------------------------------------------------------------
 Description:
   UART receive interrupt
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    short int m_rcv_data;
    char lp_slot, lp_data;
    short int calc_checksum;

    m_rcv_data = LIN_U_RB;

    switch(lin_state){
    /* SLEEP */
    case LIN_IS_SLEEP:
        /* Check UART error */
        if(m_rcv_data & 0x8000){
            LS_EnableReceiveWakeUp();
        }
        /* Check Wake-Up frame data (00h, 80h, C0h) */
        else if(m_rcv_data & 0x003F){
        }
        /* Receive Wake-Up */
        else{
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_ResetBuffer();
            lb_state = LIN_ST_RUN;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        break;
    /* IDLE or WAKEUP */
    case LIN_IS_IDLE:
    case LIN_IS_WAKEUP:
        /* Check SynchBreak */
        if(m_rcv_data & 0x01FF){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
        }
        /* Check SynchBreak 2 */
        else if(!(m_rcv_data & 0x2000)){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
        }
        /* Receive SynchBreak */
        else{
            LS_EnableReceiveHeader();
            LS_StartHeaderTimeoutTimer();
            lb_state = LIN_ST_RUN;
            LS_SET_LIN_STATE(LIN_IS_SF);
        }
        break;
    /* SYNCH FIELD */
    case LIN_IS_SF:
        /* Check UART error */
        if(m_rcv_data & 0x8000){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            lb_uart_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        /* Check SynchField (55h) */
        else if((m_rcv_data&0xFF) != 0x55){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            lb_synch_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        /* Receive SynchField */
        else{
            LS_SET_LIN_STATE(LIN_IS_ID);
        }
        break;
    /* IDENT FIELD */
    case LIN_IS_ID:
        /* Check UART error */
        if(m_rcv_data & 0x8000){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            lb_uart_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        /* Check Parity error */
        else if((m_rcv_data&0xFF) != LS_ID_TBL[m_rcv_data&0x3F]){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            lb_parity_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        /* Receive IDENT FIELD */
        else{
            /* Get Receive data */
            lin_tmp.byte = 0;
            lin_tmp.identifier = m_rcv_data&0x3F;
            lin_tmp.byte_max = lin_dlc_buffer[lin_tmp.identifier];
            LS_SET_LIN_STATE(LIN_IS_RD);
#if LIN_SND_NUM
            for(lp_slot=0; lp_slot<LIN_SND_NUM; lp_slot++){
                if(lb_sndreq(lp_slot) == LIN_REQ_SND){
                    if(lin_tmp.identifier == (lb_sndid(lp_slot)&0x3F)){
                        lin_tmp.slot = lp_slot;
                        calc_checksum = 0;
                        for(lp_data=0; lp_data<lin_tmp.byte_max; lp_data++){
                            lin_tmp.data[lp_data] = lb_snddata(lp_slot, lp_data);
                            calc_checksum += lin_tmp.data[lp_data];
                        }
                        calc_checksum = ((calc_checksum&0xFF) + ((calc_checksum>>8)&0xFF));
                        calc_checksum = ((calc_checksum&0xFF) + ((calc_checksum>>8)&0xFF));
                        lin_tmp.checksum = ~((char)calc_checksum);
                        lb_sndsts(lp_slot) = LIN_STS_RUN;
                        LS_EnableTransmitResponse();
                        LIN_U_TB = lin_tmp.data[0];
                        LS_SET_LIN_STATE(LIN_IS_SD);
                        break;
                    }
                }
            }
            if(lp_slot == LIN_SND_NUM){
#endif
#if LIN_RCV_NUM
                for(lp_slot=0; lp_slot<LIN_RCV_NUM; lp_slot++){
                    if(lb_rcvreq(lp_slot)==LIN_REQ_RCV){
                        if(lin_tmp.identifier == (lb_rcvid(lp_slot)&0x3F)){
                            if(lb_rcvsts(lp_slot)==LIN_STS_END)
                                lb_rcvsts(lp_slot) = LIN_STS_RUN;
                            break;
                        }
                    }
                }
                lin_tmp.slot = lp_slot;
#endif
#if LIN_SND_NUM
            }
#endif
        }
        LS_StartFrameTimeoutTimer();
        break;
    /* DATA FIELD */
    case LIN_IS_RD:
        /* Check UART error */
        if(m_rcv_data & 0x8000){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_ReceiveError();
            lb_uart_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        /* Get receive data */
        else{
            lin_tmp.data[lin_tmp.byte] = m_rcv_data&0xFF;
            lin_tmp.byte++;
            if(lin_tmp.byte == lin_tmp.byte_max){
                LS_SET_LIN_STATE(LIN_IS_RCS);
            }
        }
        break;
    /* CHECKSUM FIELD */
    case LIN_IS_RCS:
        /* Check UART error */
        if(m_rcv_data & 0x8000){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_ReceiveError();
            lb_uart_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        /* Get Checksum data */
        else{
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_SET_LIN_STATE(LIN_IS_IDLE);
            lin_tmp.checksum = m_rcv_data&0xFF;
#if LIN_RCV_NUM
            for(lp_slot=0; lp_slot<LIN_RCV_NUM; lp_slot++){
                if((lb_rcvreq(lp_slot) == LIN_REQ_RCV) && (lb_rcvsts(lp_slot) != LIN_STS_END)){
                    if(lin_tmp.identifier == (lb_rcvid(lp_slot)&0x3F)){
                        calc_checksum = 0;
                        for(lp_data=0; lp_data<lin_tmp.byte_max; lp_data++){
                            calc_checksum += lin_tmp.data[lp_data];
                        }
                        calc_checksum = ((calc_checksum&0xFF) + ((calc_checksum>>8)&0xFF)); /* Checksum */
                        calc_checksum = ((calc_checksum&0xFF) + ((calc_checksum>>8)&0xFF)); /* Checksum */
                        if(calc_checksum+lin_tmp.checksum != 0xFF){
                            LS_ReceiveError();
                            lb_checksum_error = LIN_ERR;
                        }
                        else{
                            lb_rcvsts(lp_slot) = LIN_STS_RUN;
                            for(lp_data=0; lp_data<lin_tmp.byte_max; lp_data++){
                                lb_rcvdata(lp_slot, lp_data) = lin_tmp.data[lp_data];
                            }
                            lb_rcvcs(lp_slot) = lin_tmp.checksum;
                            lb_rcvsts(lp_slot) = LIN_STS_END;
                            lb_rcv_comp |= ~LS_COMP_MASK[lp_slot];
                            LS_ReceiveSuccess();
                            if((lin_tmp.identifier == LIN_ID_COMMAND) && (lin_tmp.data[0] == LIN_DATA_SLEEP)){
                                l_sleep();
                            }
                        }
                        break;
                    }
                }
            }
            if(lp_slot==LIN_RCV_NUM) {
#endif
                if((lin_tmp.identifier == LIN_ID_COMMAND) && (lin_tmp.data[0] == LIN_DATA_SLEEP)){
                    calc_checksum = 0;
                    for(lp_data=0; lp_data<lin_tmp.byte_max; lp_data++){
                        calc_checksum += lin_tmp.data[lp_data];
                    }
                    calc_checksum = ((calc_checksum&0xFF) + ((calc_checksum>>8)&0xFF));
                    calc_checksum = ((calc_checksum&0xFF) + ((calc_checksum>>8)&0xFF));
                    if(calc_checksum+lin_tmp.checksum == 0xFF){
                        l_sleep();
                    }
                }

#if LIN_RCV_NUM
            }
#endif
        }
        break;
    /* other */
    default:
        LS_EnableReceiveSynchBreak();
        LS_StartNoBusActivityTimer();
        LS_SET_LIN_STATE(LIN_IS_IDLE);
    }

}


#pragma INTERRUPT LS_LinSndInt
/*>>*+*********************************************************************/
void LS_LinSndInt(void);
void LS_LinSndInt(void)
/*------------------------------------------------------------------------
 Description:
   UART transmit interrupt
--------------------------------------------------------------------------
 Input:     no
 Output:    no
 After:     no
 Note:      no
***********************************************************************<<*/
{
    short int m_rcv_data;
    unsigned char  lc;

    for(lc = 0; lc < 0xff; lc++){
        if(LIN_U_C1 & 0x08)    break;
    }

    m_rcv_data = LIN_U_RB;

    switch(lin_state){
    case LIN_IS_WAKEUP:
        if(lc == 0xff){
            LS_EnableReceiveWakeUp();
            lb_wakeup_error = LIN_ERR;
        }
        else if(m_rcv_data & 0x8000){
            LS_EnableReceiveWakeUp();
            lb_wakeup_error = LIN_ERR;
        }
        else if((m_rcv_data&0xFF) != 0x80){
            LS_EnableReceiveWakeUp();
            lb_wakeup_error = LIN_ERR;
        }
        else{
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_ResetBuffer();
        }
        break;
    case LIN_IS_SD:
        if(lc == 0xff){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_TransmitError();
            lb_bit_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE); 
        }
        else if(m_rcv_data & 0x8000){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_TransmitError();
            lb_uart_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        else if((m_rcv_data&0xFF) != lin_tmp.data[lin_tmp.byte]){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_TransmitError();
            lb_bit_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        else{
            lin_tmp.byte++;
            if(lin_tmp.byte < lin_tmp.byte_max){
                LIN_U_TB = lin_tmp.data[lin_tmp.byte];
            }
            else{
                LIN_U_TB = lin_tmp.checksum;
                LS_SET_LIN_STATE(LIN_IS_SCS);
            }
        }
        break;
    case LIN_IS_SCS:
        if(lc == 0xff){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_TransmitError();
            lb_bit_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        else if(m_rcv_data & 0x8000){
            LS_EnableReceiveSynchBreak();

            LS_StartNoBusActivityTimer();
            LS_TransmitError();
            lb_uart_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        else if((m_rcv_data&0xFF) != lin_tmp.checksum){
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_TransmitError();
            lb_bit_error = LIN_ERR;
            LS_SET_LIN_STATE(LIN_IS_IDLE);
        }
        else{
            LS_EnableReceiveSynchBreak();
            LS_StartNoBusActivityTimer();
            LS_SET_LIN_STATE(LIN_IS_IDLE);
#if LIN_SND_NUM
            lb_sndsts(lin_tmp.slot) = LIN_STS_END;
            lb_snd_comp |= ~LS_COMP_MASK[lin_tmp.slot];
            LS_TransmitSuccess();
#endif
        }
        break;
    /* other */
    default:
        LS_EnableReceiveSynchBreak();
        LS_StartNoBusActivityTimer();
        LS_SET_LIN_STATE(LIN_IS_IDLE);
    }

}
