/*
 *	TOPPERS/NonOSΉLINʐM~hEFA
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		NonOSΉLINʐM~hEFASlavepbP[W
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *	Version 1.00  2007.10.29
 */

#ifndef __SLIN_H_INCLUDE__
#define __SLIN_H_INCLUDE__

#include "slin_def.h"

/*** UART definition ***/
/* UART BRG */
#define LIN_BRG     (207)

/* UART count source */
#define LIN_BRGSRC  (1)

/*** Global definition ***/
#define l_bool  int
#define l_u8    char
#define l_u16   short int

/* Error Code */
#define E_OK        (0)
#define E_NG        (1)

/*--- LIN buffer ---*/
/* LIN buffer configuration */
typedef struct{
    l_u8    master_id:4;
    l_u8    slave_id:4;
}slib_config_def;
/* LIN buffer slot size */
typedef struct{
    l_u8    snd_slot_max:4;
    l_u8    rcv_slot_max:4;
}slib_size_def;
/* lin status */
typedef struct{
    l_u8    state:2;
    l_u8    reserve:6;
}slib_state_def;
/* complete flag */
typedef union slib_comp_flag_def{
    struct{
        l_u8    slot0:1;
        l_u8    slot1:1;
        l_u8    slot2:1;
        l_u8    slot3:1;
        l_u8    slot4:1;
        l_u8    slot5:1;
        l_u8    slot6:1;
        l_u8    slot7:1;
    }BIT;
    l_u8 BYTE;
};
typedef union slib_err_flag_def{
    struct{
        l_u8    uart:1;
        l_u8    wakeup:1;
        l_u8    bit_error:1;
        l_u8    checksum_error:1;
        l_u8    parity_error:1;
        l_u8    response_error:1;
        l_u8    synch_error:1;
        l_u8    no_bus_activity:1;
    }BIT;
    l_u8 BYTE;
};
typedef union slib_com_def{
    struct{
        l_u8    req:2;
        l_u8    sts:2;
        l_u8    reserve:2;
        l_u8    err_sum:1;
        l_u8    err_msglost:1;
    }BIT;
    l_u8 BYTE;
};

typedef struct{
    l_u8    slot;
    union slib_com_def com;
    l_u8    id;
    l_u8    data[8];
    l_u8    checksum;
}slib_slot_def;

typedef struct{
    slib_config_def         config;
    slib_size_def           size;
    slib_state_def          state;
    union slib_comp_flag_def snd_flg;
    union slib_comp_flag_def rcv_flg;
    union slib_err_flag_def err_flg;
#if LIN_SND_NUM
    slib_slot_def sndslot[LIN_SND_NUM];
#endif
#if LIN_RCV_NUM
    slib_slot_def rcvslot[LIN_RCV_NUM];
#endif
}slib_buffer_def;
extern slib_buffer_def  lin_buffer;

extern unsigned char lin_dlc_buffer[64];

/* configuration */
#define lb_masterid     lin_buffer.config.master_id
#define lb_slaveid      lin_buffer.config.slave_id
#define lb_snd_slot_max lin_buffer.size.snd_slot_max
#define lb_rcv_slot_max lin_buffer.size.rcv_slot_max

/* state */
#define lb_state        lin_buffer.state.state
#define LIN_ST_RESET        (0)
#define LIN_ST_SLEEP        (1)
#define LIN_ST_RUN          (2)
#define LIN_ST_WAKEUP       (3)

/* transmit complete flag */
#define lb_snd_comp     lin_buffer.snd_flg.BYTE
#define lb_snd_comp0    lin_buffer.snd_flg.BIT.slot1
#define lb_snd_comp1    lin_buffer.snd_flg.BIT.slot2
#define lb_snd_comp2    lin_buffer.snd_flg.BIT.slot3
#define lb_snd_comp3    lin_buffer.snd_flg.BIT.slot4
#define lb_snd_comp4    lin_buffer.snd_flg.BIT.slot5
#define lb_snd_comp5    lin_buffer.snd_flg.BIT.slot6
#define lb_snd_comp6    lin_buffer.snd_flg.BIT.slot7
#define lb_snd_comp7    lin_buffer.snd_flg.BIT.slot0
#define LIN_NOTYET      (0)
#define LIN_COMPLETED   (1)

/* receive complete flag */
#define lb_rcv_comp     lin_buffer.rcv_flg.BYTE
#define lb_rcv_comp0    lin_buffer.rcv_flg.BIT.slot1
#define lb_rcv_comp1    lin_buffer.rcv_flg.BIT.slot2
#define lb_rcv_comp2    lin_buffer.rcv_flg.BIT.slot3
#define lb_rcv_comp3    lin_buffer.rcv_flg.BIT.slot4
#define lb_rcv_comp4    lin_buffer.rcv_flg.BIT.slot5
#define lb_rcv_comp5    lin_buffer.rcv_flg.BIT.slot6
#define lb_rcv_comp6    lin_buffer.rcv_flg.BIT.slot7
#define lb_rcv_comp7    lin_buffer.rcv_flg.BIT.slot0

/* error flag */
#define lb_err_flg          lin_buffer.err_flg.BYTE
#define lb_uart_error       lin_buffer.err_flg.BIT.uart
#define lb_wakeup_error     lin_buffer.err_flg.BIT.wakeup
#define lb_bit_error        lin_buffer.err_flg.BIT.bit_error
#define lb_checksum_error   lin_buffer.err_flg.BIT.checksum_error
#define lb_parity_error     lin_buffer.err_flg.BIT.parity_error
#define lb_response_error   lin_buffer.err_flg.BIT.response_error
#define lb_synch_error      lin_buffer.err_flg.BIT.synch_error
#define lb_no_bus_activity  lin_buffer.err_flg.BIT.no_bus_activity
#define LIN_NO_ERR          (0)
#define LIN_ERR             (1)

/* transmit slot */
#if LIN_SND_NUM
#define lb_sndslot(x)       lin_buffer.sndslot[x].slot
#define lb_sndreg(x)        lin_buffer.sndslot[x].com.BYTE
#define lb_sndreq(x)        lin_buffer.sndslot[x].com.BIT.req
#define lb_sndsts(x)        lin_buffer.sndslot[x].com.BIT.sts
#define lb_snderr(x)        lin_buffer.sndslot[x].com.BIT.err_sum
#define lb_snddlc(x)        lin_buffer.sndslot[x].dlc
#define lb_sndid(x)         lin_buffer.sndslot[x].id
#define lb_snddata(x,y)     lin_buffer.sndslot[x].data[y]
#define lb_sndcs(x)         lin_buffer.sndslot[x].checksum
#endif

/* receive slot */
#if LIN_RCV_NUM
#define lb_rcvslot(x)       lin_buffer.rcvslot[x].slot
#define lb_rcvreg(x)        lin_buffer.rcvslot[x].com.BYTE
#define lb_rcvreq(x)        lin_buffer.rcvslot[x].com.BIT.req
#define lb_rcvsts(x)        lin_buffer.rcvslot[x].com.BIT.sts
#define lb_rcverr(x)        lin_buffer.rcvslot[x].com.BIT.err_sum
#define lb_rcvover(x)       lin_buffer.rcvslot[x].com.BIT.err_msglost
#define lb_rcvdlc(x)        lin_buffer.rcvslot[x].dlc
#define lb_rcvid(x)         lin_buffer.rcvslot[x].id
#define lb_rcvdata(x,y)     lin_buffer.rcvslot[x].data[y]
#define lb_rcvcs(x)         lin_buffer.rcvslot[x].checksum
#endif

#define LIN_REQ_IDLE        (0)
#define LIN_REQ_SND         (1)
#define LIN_REQ_RCV         (2)
#define LIN_STS_IDLE        (0)
#define LIN_STS_REQ         (1)
#define LIN_STS_RUN         (2)
#define LIN_STS_END         (3)

#define LIN_DEFAULT_SNDREG  (0)
#define LIN_DEFAULT_RCVREG  (0)



/*--- LIN communication setting for device ---*/
/*** LIN Slave API ***/
/* LIN packet message */
typedef struct{
    l_u8    identifier;
    l_u8    data[8];
}slib_lin_frame_def;

/* initialization of the LIN SW */
extern l_bool l_sys_init(void);
    /*  [E_OK]: succeeded
        [E_NG]: failed              */
/* initialization of the contoller */
extern void l_ifc_init(void);
/* connect the interface to the LIN network */
extern l_bool l_ifc_connect(void);
    /*  [E_OK]: succeeded
        [E_NG]: failed              */
/* disconnect the interface from the LIN network */
extern l_bool l_ifc_disconnect(void);
    /*  [E_OK]: succeeded
        [E_NG]: failed              */
/* send wake-up frame */
extern l_bool l_wakeup(void);
    /*  [E_OK]: succeeded
        [E_NG]: failed              */
extern l_bool l_sleep(void);
    /*  [E_OK]: succeeded
        [E_NG]: failed              */
extern l_bool l_run(void);
    /*  [E_OK]: succeeded
        [E_NG]: failed              */
/* send request */
#if LIN_SND_NUM
extern l_bool l_set_sndreq(slib_slot_def *lin_frame);
extern l_bool l_stop_sndreq(slib_slot_def *lin_frame);
extern l_u8 l_read_sndsts(slib_slot_def *lin_frame);
extern l_bool l_clr_sndsts(slib_slot_def *lin_frame);
extern void l_set_snddata(slib_slot_def *lin_fram, l_u8 *lin_buffer);
#endif

/* receive request */
#if LIN_RCV_NUM
extern l_bool l_set_rcvreq(slib_slot_def *lin_frame);
extern l_bool l_stop_rcvreq(slib_slot_def *lin_frame);
extern l_u8 l_read_rcvsts(slib_slot_def *lin_frame);
extern l_bool l_clr_rcvsts(slib_slot_def *lin_frame);
extern l_bool l_get_rcvdata(slib_slot_def *lin_fram, l_u8 *lin_buffer);
#endif

#if LIN_SND_NUM
/* transmit slot id */
extern const unsigned char LIN_SNDFRMID_TBL[LIN_SND_NUM];
#endif

#if LIN_RCV_NUM
/* receive slot id */
extern const unsigned char LIN_RCVFRMID_TBL[LIN_RCV_NUM];
#endif

#endif /* __SLIN_H_INCLUDE__ */
