/*
 *	TOPPERS/NonOSΉLINʐM~hEFA
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		NonOSΉLINʐM~hEFASlavepbP[W
 * 
 *	Copyright (C) 2007 Sunny Giken Inc.
 * 
 *	L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *	ɂČ\Ă GNU General Public License  Version 2 ɋL
 *	qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *	ς̂܂ށDȉjgpEEρEĔzziȉC
 *	pƌĂԁj邱Ƃ𖳏ŋD
 *	(1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *		\C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *		XR[hɊ܂܂Ă邱ƁD
 *	(2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *		pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *		҃}jAȂǁjɁCL̒쌠\C̗pщL
 *		̖ۏ؋Kfڂ邱ƁD
 *	(3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *		płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *		ƁD
 *	  (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *		  쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *	  (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *		  񍐂邱ƁD
 *	(4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *		QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *	{\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *	TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *	܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *	ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */
/*
 *	Version 1.00  2007.10.29
 */

#ifndef __SLINSFR_H_INCLUDE__
#define __SLINSFR_H_INCLUDE__

/*---------------------------------------------------------------------*/
/*  Settings of Interrupt Priority Levels                              */
/*---------------------------------------------------------------------*/
#define LIN_UT_INTLEVEL     (5)
#define LIN_UR_INTLEVEL     (6)
#define LIN_TIMER_INTLEVEL  (5)

/*---------------------------------------------------------------------*/
/*  Please do not change the following.                                */
/*---------------------------------------------------------------------*/

/********************************************************
*   declare SFR bit                                     *
********************************************************/
/*  Byte 8bit  */
typedef struct{
    unsigned char   b0:1;
    unsigned char   b1:1;
    unsigned char   b2:1;
    unsigned char   b3:1;
    unsigned char   b4:1;
    unsigned char   b5:1;
    unsigned char   b6:1;
    unsigned char   b7:1;
} bit_byte_def;

typedef union{
    bit_byte_def    bit;
    unsigned char   byte;
} byte_def;

/*  Word 16Bit  */
typedef struct{
    unsigned char   b0:1;
    unsigned char   b1:1;
    unsigned char   b2:1;
    unsigned char   b3:1;
    unsigned char   b4:1;
    unsigned char   b5:1;
    unsigned char   b6:1;
    unsigned char   b7:1;
    unsigned char   b8:1;
    unsigned char   b9:1;
    unsigned char   b10:1;
    unsigned char   b11:1;
    unsigned char   b12:1;
    unsigned char   b13:1;
    unsigned char   b14:1;
    unsigned char   b15:1;
} bit_word_def;

typedef union{
    bit_word_def    bit;
    struct{
        unsigned char   low;
        unsigned char   high;
    }byte;
    unsigned int    word;
} word_def;

/********************************************************
*   declare SFR addresses                               *
********************************************************/
#pragma ADDRESS LIN_PS0_ADDR         03b0h
byte_def    LIN_PS0_ADDR;
#define LIN_PS0_2 LIN_PS0_ADDR.bit.b2
#define LIN_PS0_3 LIN_PS0_ADDR.bit.b3
#pragma ADDRESS PD6_ADDR         03c2h
byte_def    PD6_ADDR;
#define LIN_PD6_2 PD6_ADDR.bit.b2

/*** UART ***/
#pragma ADDRESS LIN_U_TB_ADDR        036ah
#pragma ADDRESS LIN_U_RB_ADDR        036eh
#pragma ADDRESS LIN_U_BRG_ADDR       0369h
#pragma ADDRESS LIN_U_MR_ADDR        0368h
#pragma ADDRESS LIN_U_C0_ADDR        036ch
#pragma ADDRESS LIN_U_C1_ADDR        036dh
byte_def    LIN_U_C1_ADDR;
#define LIN_U_IRS LIN_U_C1_ADDR.bit.b4
#pragma ADDRESS LIN_U_TIC_ADDR       0090h
#pragma ADDRESS LIN_U_RIC_ADDR       0072h

word_def    LIN_U_TB_ADDR;
word_def    LIN_U_RB_ADDR;
byte_def    LIN_U_BRG_ADDR;
byte_def    LIN_U_MR_ADDR;
byte_def    LIN_U_C0_ADDR;
byte_def    LIN_U_TIC_ADDR;
byte_def    LIN_U_RIC_ADDR;

#define LIN_U_TB    LIN_U_TB_ADDR.word
#define LIN_U_RB    LIN_U_RB_ADDR.word
#define LIN_U_BRG   LIN_U_BRG_ADDR.byte
#define LIN_U_MR    LIN_U_MR_ADDR.byte
#define LIN_U_C0    LIN_U_C0_ADDR.byte
#define LIN_U_C1    LIN_U_C1_ADDR.byte
#define LIN_U_TIC   LIN_U_TIC_ADDR.byte
#define LIN_U_RIC   LIN_U_RIC_ADDR.byte


/*** TIMER for measurmenbt frame time-out and No-Bus-Activity ***/
#pragma ADDRESS     LIN_TIMER_TABSR_ADDR  0340h

byte_def    LIN_TIMER_TABSR_ADDR;

/* TIMER A0 */
#pragma ADDRESS LIN_TIMER_MR_ADDR        0356h
#pragma ADDRESS LIN_TIMER_TIMER_ADDR     0346h
#define LIN_TIMER_START LIN_TIMER_TABSR_ADDR.bit.b0
#pragma ADDRESS LIN_TIMER_IC_ADDR        006Ch

byte_def    LIN_TIMER_MR_ADDR;
word_def    LIN_TIMER_TIMER_ADDR;
byte_def    LIN_TIMER_IC_ADDR;

#define LIN_TIMER_MR    LIN_TIMER_MR_ADDR.byte
#define LIN_TIMER_TIMER LIN_TIMER_TIMER_ADDR.word
#define LIN_TIMER_IC    LIN_TIMER_IC_ADDR.byte


#endif
